/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsaddtable
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Add a table to a dataset
	Description: Add a table to a dataset


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>


#include "dsaddtable.h"

void dsaddtable()
{
	PROC
	const string		setName( stringParameter( "set" ));
	const string		name( stringParameter( "name" ));
	const int		rows( intParameter( "rows" ) );
	//const bool		withLabel( booleanParameter( "withlabel" ) );
	const string		label( stringParameter( "label" ));
	const bool		withPosition( booleanParameter( "withposition" ) );
	int			position( intParameter( "position" ));

	DataSet*		dataSet( dataSetServer -> open( setName, DataSet::Modify ) );
	Table*			table;

	if( withPosition )
	{
		table = dataSet -> addTable( name, rows, label, position );
	}
	else
	{
		table = dataSet -> addTable( name, rows, label );
	}// if

	dataSetServer -> close( dataSet );

	ENDPROC
}
