/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dscopyblock
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Copy a list of blocks to a dataset
	Description: Copy a list of blocks to a dataset


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>


#include "dscopyblock.h"

void dscopyblock()
{
	PROC
	const vector<string>	blocks( stringListParameter( "blocks" ) );
	string			to( stringParameter( "to" ) );
	DataSet*		dsnSet( dataSetServer -> open( to, Dal::Modify ) );

	for( unsigned int i = 0; i < blocks.size(); ++i )
	{
		const string		name( blocks[ i ] );
		DataSet*		srcSet( dataSetServer -> open( name, Dal::Read ) );
		Block*			srcBlock( srcSet -> block( name ) );

		dsnSet -> add( srcBlock );
		dataSetServer -> close( srcSet );

	} // for
	dataSetServer -> close( dsnSet );
	ENDPROC
}
