/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsdeletenullvalue
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Delete the null value from an array or column
	Description: Delete the null value from an array or column


*/

#include <Tracer.h>
#include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>



#include "dsdeletenullvalue.h"

void dsdeletenullvalue()
{
	PROC
	const vector<string>	objects( stringListParameter( "objects" ) );

	for( unsigned int i = 0; i < objects.size(); ++i )
	{
		const string		name( objects[ i ] );
		DataSet*		set( dataSetServer -> open( name, Dal::Modify, DataSetServer::Low ) );
		const CompoundName	cn( name, CompoundName::Any, set );

		switch( cn.state() )
		{
			case CompoundName::ArrayName :
			{
				Array*	array = cn.array();
				if( array -> nullDefined() )
				{
					array -> deleteNullValue();
				} // if
			}
				break;
			case CompoundName::ColumnName :
			{
				Column* column = cn.column();
				if( column -> nullDefined() )
				{
					column -> deleteNullValue();
				} // if
			}
				break;
			default :
				errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );
		} // switch

		//if( set )
		//{
			dataSetServer -> close( set );
		//} // if
	} // for
	ENDPROC
}
