/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsrename
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Rename an object
	Description: Rename an object


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>


#include "dsrename.h"

void dsrename()
{
	PROC
	const string		name( stringParameter( "object" ) );
	const string		newName( stringParameter( "newname" ) );

	DataSet*		set( dataSetServer -> open( name, Dal::Modify, DataSetServer::Low ) );
	const CompoundName	cn( name, CompoundName::Any, set );

	switch( cn.state() )
	{
		case CompoundName::DataSetName :
			set -> rename( newName);
			break;
		case CompoundName::BlockName :
		case CompoundName::TableName :
		case CompoundName::ArrayName :
			set -> block( name ) -> rename( newName );
			break;
		case CompoundName::ColumnName :
			set -> table( name ) -> column( name ) -> rename( newName );
			break;
		case CompoundName::DataSetAttributeName :
		case CompoundName::BlockAttributeName :
		case CompoundName::ColumnAttributeName :
			cn.attributable() -> attribute( name ) -> rename( newName );
			break;
		default :
			errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );
	} // switch

	dataSetServer -> close( set );

	ENDPROC
}
