/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dsrm
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Delete a list of objects
	Description: Delete a list of objects


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>


#include "dsrm.h"

void dsrm()
{
	PROC
	const vector<string>	objects( stringListParameter( "objects" ) );

	for( unsigned int i = 0; i < objects.size(); ++i )
	{
		const string		name( objects[ i ] );
		DataSet*		set( dataSetServer -> open( name, Dal::Modify, DataSetServer::Low ) );
		const CompoundName	cn( name, CompoundName::Any, set );

		switch( cn.state() )
		{
			case CompoundName::DataSetName :
				dataSetServer -> close( set );
				dataSetServer -> remove( name );
				set = 0;
				break;
			case CompoundName::BlockName :
			case CompoundName::TableName :
			case CompoundName::ArrayName :
				set -> deleteBlock( name );
				break;
			case CompoundName::ColumnName :
				set -> table( name ) -> deleteColumn( name );
				break;
			case CompoundName::DataSetAttributeName :
			case CompoundName::BlockAttributeName :
			case CompoundName::ColumnAttributeName :
				cn.attributable() -> deleteAttribute( name );
				break;
			default :
				errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );
		} // switch

		if( set )
		{
			dataSetServer -> close( set );
		} // if
	} // for
	ENDPROC
}
