/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dssetnullvalue
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Set the null value of an array or column
	Description: Set the null value of an array or column


*/

#include <Tracer.h>
#include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>



#include "dssetnullvalue.h"

void dssetnullvalue()
{
	PROC
	const vector<string>	objects( stringListParameter( "objects" ) );
	const int		nullValue( intParameter( "value" ) );

	for( unsigned int i = 0; i < objects.size(); ++i )
	{
		const string		name( objects[ i ] );
		DataSet*		set( dataSetServer -> open( name, Dal::Modify, DataSetServer::Low ) );
		const CompoundName	cn( name, CompoundName::Any, set );

		switch( cn.state() )
		{
			case CompoundName::ArrayName :
				set -> array( name ) -> nullValue( nullValue );
				break;
			case CompoundName::ColumnName :
				set -> table( name ) -> column( name ) -> nullValue( nullValue );
				break;
			default :
				errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );
		} // switch

		//if( set )
		//{
			dataSetServer -> close( set );
		//} // if
	} // for
	ENDPROC
}
