/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dssetunits
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Set the units of an array, column or attribute
	Description: Set the units of an array, column or attribute


*/

#include <Tracer.h>
#include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <CompoundName.h>



#include "dssetunits.h"

void dssetunits()
{
	const string	name( stringParameter( "object" ) );
	const string	units( stringParameter( "units" ) );

	DataSet*		set( dataSetServer -> open( name, Dal::Read, DataSetServer::Low ) );
	const CompoundName	cn( name, CompoundName::Any, set );

	switch( cn.state() )
	{
		case CompoundName::ArrayName :
			set -> array( name ) -> units( units );
			break;

		case CompoundName::ColumnName :
			set -> table( name ) -> column( name ) -> units( units );
			break;
		case CompoundName::DataSetAttributeName :
			set -> attribute( name ) -> units( units );
			break;
		case CompoundName::BlockAttributeName :
			set -> block( name ) -> attribute( name ) -> units( units );
			break;
		case CompoundName::ColumnAttributeName :
			set -> table( name ) -> column( name ) -> attribute( name ) -> units( units );
			break;
		default :
			errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );

		dataSetServer -> close( set );
	} // switch
	ENDPROC
}

